Index: npl/syn3/webint/src/lang_en.php
===================================================================
--- npl/syn3/webint/src/lang_en.php	(revision 90f43e52628c9bbe952fdbbbe4183772a6675fb2)
+++ npl/syn3/webint/src/lang_en.php	(revision 031ab693def62c4aaf3e6440e1655c4fe368b6c4)
@@ -125,9 +125,9 @@
 
 function _ErrorFilenameIsInvalid($a="",$b="",$c="",$d="") { return (
-	"_ErrorFilenameIsInvalid($a,$b,$c,$d)"
+	"Filename has invalid characters"
 );}
 
 function _ErrorFilenameIsRequired($a="",$b="",$c="",$d="") { return (
-	"_ErrorFilenameIsRequired($a,$b,$c,$d)"
+	"Enter filename"
 );}
 
@@ -242,4 +242,12 @@
 function _ErrorSharenameIsRequired($a="",$b="",$c="",$d="") { return (
 	"Enter a share name."
+);}
+
+function _ErrorSubnetIsInvalid($a="",$b="",$c="",$d="") { return (
+	"Invalid subnet (use CIDR format, e.g. 10.0.0.0/24)"
+);}
+
+function _ErrorSubnetIsRequired($a="",$b="",$c="",$d="") { return (
+	"Subnet is required (in CIRD form)"
 );}
 
Index: npl/syn3/webint/src/lang_enD.php
===================================================================
--- npl/syn3/webint/src/lang_enD.php	(revision 90f43e52628c9bbe952fdbbbe4183772a6675fb2)
+++ npl/syn3/webint/src/lang_enD.php	(revision 031ab693def62c4aaf3e6440e1655c4fe368b6c4)
@@ -124,10 +124,10 @@
 );}
 
-function _ErrorFilenameIsInvalid($a="",$b="",$c="",$d="") { LangDebug("_ErrorFilenameIsInvalid($a,$b,$c,$d)", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=en&add_labelID=_ErrorFilenameIsInvalid");return (
-	"_ErrorFilenameIsInvalid($a,$b,$c,$d)"
-);}
-
-function _ErrorFilenameIsRequired($a="",$b="",$c="",$d="") { LangDebug("_ErrorFilenameIsRequired($a,$b,$c,$d)", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=en&add_labelID=_ErrorFilenameIsRequired");return (
-	"_ErrorFilenameIsRequired($a,$b,$c,$d)"
+function _ErrorFilenameIsInvalid($a="",$b="",$c="",$d="") { LangDebug("Filename has invalid characters", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?edit_ID=8319");return (
+	"Filename has invalid characters"
+);}
+
+function _ErrorFilenameIsRequired($a="",$b="",$c="",$d="") { LangDebug("Enter filename", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?edit_ID=8320");return (
+	"Enter filename"
 );}
 
@@ -242,4 +242,12 @@
 function _ErrorSharenameIsRequired($a="",$b="",$c="",$d="") { LangDebug("Enter a share name.", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?edit_ID=1082");return (
 	"Enter a share name."
+);}
+
+function _ErrorSubnetIsInvalid($a="",$b="",$c="",$d="") { LangDebug("Invalid subnet (use CIDR format, e.g. 10.0.0.0/24)", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?edit_ID=8322");return (
+	"Invalid subnet (use CIDR format, e.g. 10.0.0.0/24)"
+);}
+
+function _ErrorSubnetIsRequired($a="",$b="",$c="",$d="") { LangDebug("Subnet is required (in CIRD form)", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?edit_ID=8321");return (
+	"Subnet is required (in CIRD form)"
 );}
 
Index: npl/syn3/webint/src/lang_nl.php
===================================================================
--- npl/syn3/webint/src/lang_nl.php	(revision 90f43e52628c9bbe952fdbbbe4183772a6675fb2)
+++ npl/syn3/webint/src/lang_nl.php	(revision 031ab693def62c4aaf3e6440e1655c4fe368b6c4)
@@ -244,4 +244,12 @@
 );}
 
+function _ErrorSubnetIsInvalid($a="",$b="",$c="",$d="") { return (
+	"Subnet is ongeldig (gebruik CIDR vorm, bijv. 10.0.0.0/24)"
+);}
+
+function _ErrorSubnetIsRequired($a="",$b="",$c="",$d="") { return (
+	"Subnet is vereist. (in CIDR vorm)"
+);}
+
 function _ErrorValidChoiceIsRequired($a="",$b="",$c="",$d="") { return (
 	"U moet een geldig keus maken!"
Index: npl/syn3/webint/src/lang_nlD.php
===================================================================
--- npl/syn3/webint/src/lang_nlD.php	(revision 90f43e52628c9bbe952fdbbbe4183772a6675fb2)
+++ npl/syn3/webint/src/lang_nlD.php	(revision 031ab693def62c4aaf3e6440e1655c4fe368b6c4)
@@ -244,4 +244,12 @@
 );}
 
+function _ErrorSubnetIsInvalid($a="",$b="",$c="",$d="") { LangDebug("Subnet is ongeldig (gebruik CIDR vorm, bijv. 10.0.0.0/24)", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?edit_ID=8307");return (
+	"Subnet is ongeldig (gebruik CIDR vorm, bijv. 10.0.0.0/24)"
+);}
+
+function _ErrorSubnetIsRequired($a="",$b="",$c="",$d="") { LangDebug("Subnet is vereist. (in CIDR vorm)", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?edit_ID=8308");return (
+	"Subnet is vereist. (in CIDR vorm)"
+);}
+
 function _ErrorValidChoiceIsRequired($a="",$b="",$c="",$d="") { LangDebug("U moet een geldig keus maken!", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?edit_ID=5426");return (
 	"U moet een geldig keus maken!"
Index: npl/syn3/webint/src/lang_pl.php
===================================================================
--- npl/syn3/webint/src/lang_pl.php	(revision 90f43e52628c9bbe952fdbbbe4183772a6675fb2)
+++ npl/syn3/webint/src/lang_pl.php	(revision 031ab693def62c4aaf3e6440e1655c4fe368b6c4)
@@ -126,9 +126,9 @@
 
 function _ErrorFilenameIsInvalid($a="",$b="",$c="",$d="") { return (
-	"_ErrorFilenameIsInvalid($a,$b,$c,$d)"
+	"Filename has invalid characters"
 );}
 
 function _ErrorFilenameIsRequired($a="",$b="",$c="",$d="") { return (
-	"_ErrorFilenameIsRequired($a,$b,$c,$d)"
+	"Enter filename"
 );}
 
@@ -245,4 +245,12 @@
 );}
 
+function _ErrorSubnetIsInvalid($a="",$b="",$c="",$d="") { return (
+	"Invalid subnet (use CIDR format, e.g. 10.0.0.0/24)"
+);}
+
+function _ErrorSubnetIsRequired($a="",$b="",$c="",$d="") { return (
+	"Subnet is required (in CIRD form)"
+);}
+
 function _ErrorValidChoiceIsRequired($a="",$b="",$c="",$d="") { return (
 	"You need to make a valid choice!"
Index: npl/syn3/webint/src/lang_plD.php
===================================================================
--- npl/syn3/webint/src/lang_plD.php	(revision 90f43e52628c9bbe952fdbbbe4183772a6675fb2)
+++ npl/syn3/webint/src/lang_plD.php	(revision 031ab693def62c4aaf3e6440e1655c4fe368b6c4)
@@ -126,10 +126,10 @@
 );}
 
-function _ErrorFilenameIsInvalid($a="",$b="",$c="",$d="") { LangDebug("_ErrorFilenameIsInvalid($a,$b,$c,$d)", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=pl&add_labelID=_ErrorFilenameIsInvalid");return (
-	"_ErrorFilenameIsInvalid($a,$b,$c,$d)"
-);}
-
-function _ErrorFilenameIsRequired($a="",$b="",$c="",$d="") { LangDebug("_ErrorFilenameIsRequired($a,$b,$c,$d)", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=pl&add_labelID=_ErrorFilenameIsRequired");return (
-	"_ErrorFilenameIsRequired($a,$b,$c,$d)"
+function _ErrorFilenameIsInvalid($a="",$b="",$c="",$d="") { LangDebug("Filename has invalid characters", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=pl&add_labelID=_ErrorFilenameIsInvalid");return (
+	"Filename has invalid characters"
+);}
+
+function _ErrorFilenameIsRequired($a="",$b="",$c="",$d="") { LangDebug("Enter filename", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=pl&add_labelID=_ErrorFilenameIsRequired");return (
+	"Enter filename"
 );}
 
@@ -246,4 +246,12 @@
 );}
 
+function _ErrorSubnetIsInvalid($a="",$b="",$c="",$d="") { LangDebug("Invalid subnet (use CIDR format, e.g. 10.0.0.0/24)", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=pl&add_labelID=_ErrorSubnetIsInvalid");return (
+	"Invalid subnet (use CIDR format, e.g. 10.0.0.0/24)"
+);}
+
+function _ErrorSubnetIsRequired($a="",$b="",$c="",$d="") { LangDebug("Subnet is required (in CIRD form)", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=pl&add_labelID=_ErrorSubnetIsRequired");return (
+	"Subnet is required (in CIRD form)"
+);}
+
 function _ErrorValidChoiceIsRequired($a="",$b="",$c="",$d="") { LangDebug("You need to make a valid choice!", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=pl&add_labelID=_ErrorValidChoiceIsRequired");return (
 	"You need to make a valid choice!"
Index: npl/syn3/webint/src/lang_pt.php
===================================================================
--- npl/syn3/webint/src/lang_pt.php	(revision 90f43e52628c9bbe952fdbbbe4183772a6675fb2)
+++ npl/syn3/webint/src/lang_pt.php	(revision 031ab693def62c4aaf3e6440e1655c4fe368b6c4)
@@ -125,9 +125,9 @@
 
 function _ErrorFilenameIsInvalid($a="",$b="",$c="",$d="") { return (
-	"_ErrorFilenameIsInvalid($a,$b,$c,$d)"
+	"Filename has invalid characters"
 );}
 
 function _ErrorFilenameIsRequired($a="",$b="",$c="",$d="") { return (
-	"_ErrorFilenameIsRequired($a,$b,$c,$d)"
+	"Enter filename"
 );}
 
@@ -242,4 +242,12 @@
 function _ErrorSharenameIsRequired($a="",$b="",$c="",$d="") { return (
 	"Enter a share name."
+);}
+
+function _ErrorSubnetIsInvalid($a="",$b="",$c="",$d="") { return (
+	"Invalid subnet (use CIDR format, e.g. 10.0.0.0/24)"
+);}
+
+function _ErrorSubnetIsRequired($a="",$b="",$c="",$d="") { return (
+	"Subnet is required (in CIRD form)"
 );}
 
Index: npl/syn3/webint/src/lang_ptD.php
===================================================================
--- npl/syn3/webint/src/lang_ptD.php	(revision 90f43e52628c9bbe952fdbbbe4183772a6675fb2)
+++ npl/syn3/webint/src/lang_ptD.php	(revision 031ab693def62c4aaf3e6440e1655c4fe368b6c4)
@@ -124,10 +124,10 @@
 );}
 
-function _ErrorFilenameIsInvalid($a="",$b="",$c="",$d="") { LangDebug("_ErrorFilenameIsInvalid($a,$b,$c,$d)", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=pt&add_labelID=_ErrorFilenameIsInvalid");return (
-	"_ErrorFilenameIsInvalid($a,$b,$c,$d)"
-);}
-
-function _ErrorFilenameIsRequired($a="",$b="",$c="",$d="") { LangDebug("_ErrorFilenameIsRequired($a,$b,$c,$d)", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=pt&add_labelID=_ErrorFilenameIsRequired");return (
-	"_ErrorFilenameIsRequired($a,$b,$c,$d)"
+function _ErrorFilenameIsInvalid($a="",$b="",$c="",$d="") { LangDebug("Filename has invalid characters", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=pt&add_labelID=_ErrorFilenameIsInvalid");return (
+	"Filename has invalid characters"
+);}
+
+function _ErrorFilenameIsRequired($a="",$b="",$c="",$d="") { LangDebug("Enter filename", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=pt&add_labelID=_ErrorFilenameIsRequired");return (
+	"Enter filename"
 );}
 
@@ -242,4 +242,12 @@
 function _ErrorSharenameIsRequired($a="",$b="",$c="",$d="") { LangDebug("Enter a share name.", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=pt&add_labelID=_ErrorSharenameIsRequired");return (
 	"Enter a share name."
+);}
+
+function _ErrorSubnetIsInvalid($a="",$b="",$c="",$d="") { LangDebug("Invalid subnet (use CIDR format, e.g. 10.0.0.0/24)", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=pt&add_labelID=_ErrorSubnetIsInvalid");return (
+	"Invalid subnet (use CIDR format, e.g. 10.0.0.0/24)"
+);}
+
+function _ErrorSubnetIsRequired($a="",$b="",$c="",$d="") { LangDebug("Subnet is required (in CIRD form)", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=pt&add_labelID=_ErrorSubnetIsRequired");return (
+	"Subnet is required (in CIRD form)"
 );}
 
Index: npl/syn3/webint/src/network/ifconfig.php
===================================================================
--- npl/syn3/webint/src/network/ifconfig.php	(revision 90f43e52628c9bbe952fdbbbe4183772a6675fb2)
+++ npl/syn3/webint/src/network/ifconfig.php	(revision 031ab693def62c4aaf3e6440e1655c4fe368b6c4)
@@ -158,4 +158,7 @@
 		}
 		NetExec("$IFCONFIG lo 127.0.0.1");
+		//for zarafa spooler and others to allow other src adresses
+		NetExec("$IFCONFIG lo:2 127.0.0.2 netmask 255.255.255.255");
+		NetExec("$IFCONFIG lo:3 127.0.0.3 netmask 255.255.255.255");
 	}
 ?>
Index: npl/syn3/webint/src/openvpn/editsettings.php
===================================================================
--- npl/syn3/webint/src/openvpn/editsettings.php	(revision 90f43e52628c9bbe952fdbbbe4183772a6675fb2)
+++ npl/syn3/webint/src/openvpn/editsettings.php	(revision 031ab693def62c4aaf3e6440e1655c4fe368b6c4)
@@ -74,4 +74,58 @@
 
 
+echo "<tr><td>";
+echo _OpenVPNRouteMode();
+echo "<td>";
+
+form_FieldRadio(array(
+	"name"		=>"ROUTE_MODE",
+	"value"		=>$fields["ROUTE_MODE"],
+	"errors"	=>$errors,
+	"radiovalue"=>"all",
+	"autosubmit"=>"1"
+));
+echo _OpenVPNRouteModeAll();
+echo "<br>";
+
+form_FieldRadio(array(
+	"name"		=>"ROUTE_MODE",
+	"value"		=>$fields["ROUTE_MODE"],
+	"errors"	=>$errors,
+	"radiovalue"=>"subnet",
+	"autosubmit"=>"1"
+));
+echo _OpenVPNRouteModeSubnet();
+
+echo "</tr>";
+
+
+if ($fields['ROUTE_MODE']=="subnet")
+{
+    echo "<tr><td>";
+    echo _OpenVPNSubnetToRoute();
+    echo "<td>";
+    form_FieldText(array(
+    	"name"		=>"SUBNET",
+    	"value"		=>$fields[SUBNET],
+    	"errors"	=>$errors,
+    	"error"		=>"",
+    	"disabled"	=>0,
+    	"length"	=>30
+    ));
+    echo "</tr>";
+}
+
+echo "<tr><td>";
+echo _OpenVPNPushDNS();
+echo "<td>";
+form_FieldText(array(
+    "name"		=>"PUSH_DNS",
+    "value"		=>$fields[PUSH_DNS],
+    "errors"	=>$errors,
+    "error"		=>"",
+    "disabled"	=>0,
+    "length"	=>30
+));
+echo "</tr>";
 
 echo "</table>";
Index: npl/syn3/webint/src/openvpn/lang_de.php
===================================================================
--- npl/syn3/webint/src/openvpn/lang_de.php	(revision 90f43e52628c9bbe952fdbbbe4183772a6675fb2)
+++ npl/syn3/webint/src/openvpn/lang_de.php	(revision 031ab693def62c4aaf3e6440e1655c4fe368b6c4)
@@ -64,4 +64,20 @@
 );}
 
+function _OpenVPNPushDNS($a="",$b="",$c="",$d="") { return (
+	"DNS server for clients"
+);}
+
+function _OpenVPNRouteMode($a="",$b="",$c="",$d="") { return (
+	"Routing mode"
+);}
+
+function _OpenVPNRouteModeAll($a="",$b="",$c="",$d="") { return (
+	"Route all internet traffic via server"
+);}
+
+function _OpenVPNRouteModeSubnet($a="",$b="",$c="",$d="") { return (
+	"Route a specific subnet"
+);}
+
 function _OpenVPNServerHost($a="",$b="",$c="",$d="") { return (
 	"OpenVPN server host"
@@ -80,4 +96,8 @@
 );}
 
+function _OpenVPNSubnetToRoute($a="",$b="",$c="",$d="") { return (
+	"Routing subnet"
+);}
+
 function _RemoteIP($a="",$b="",$c="",$d="") { return (
 	"Client IP"
Index: npl/syn3/webint/src/openvpn/lang_deD.php
===================================================================
--- npl/syn3/webint/src/openvpn/lang_deD.php	(revision 90f43e52628c9bbe952fdbbbe4183772a6675fb2)
+++ npl/syn3/webint/src/openvpn/lang_deD.php	(revision 031ab693def62c4aaf3e6440e1655c4fe368b6c4)
@@ -64,4 +64,20 @@
 );}
 
+function _OpenVPNPushDNS($a="",$b="",$c="",$d="") { LangDebug("DNS server for clients", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=de&add_labelID=_OpenVPNPushDNS");return (
+	"DNS server for clients"
+);}
+
+function _OpenVPNRouteMode($a="",$b="",$c="",$d="") { LangDebug("Routing mode", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=de&add_labelID=_OpenVPNRouteMode");return (
+	"Routing mode"
+);}
+
+function _OpenVPNRouteModeAll($a="",$b="",$c="",$d="") { LangDebug("Route all internet traffic via server", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=de&add_labelID=_OpenVPNRouteModeAll");return (
+	"Route all internet traffic via server"
+);}
+
+function _OpenVPNRouteModeSubnet($a="",$b="",$c="",$d="") { LangDebug("Route a specific subnet", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=de&add_labelID=_OpenVPNRouteModeSubnet");return (
+	"Route a specific subnet"
+);}
+
 function _OpenVPNServerHost($a="",$b="",$c="",$d="") { LangDebug("OpenVPN server host", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=de&add_labelID=_OpenVPNServerHost");return (
 	"OpenVPN server host"
@@ -80,4 +96,8 @@
 );}
 
+function _OpenVPNSubnetToRoute($a="",$b="",$c="",$d="") { LangDebug("Routing subnet", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=de&add_labelID=_OpenVPNSubnetToRoute");return (
+	"Routing subnet"
+);}
+
 function _RemoteIP($a="",$b="",$c="",$d="") { LangDebug("Client IP", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=de&add_labelID=_RemoteIP");return (
 	"Client IP"
Index: npl/syn3/webint/src/openvpn/lang_en.php
===================================================================
--- npl/syn3/webint/src/openvpn/lang_en.php	(revision 90f43e52628c9bbe952fdbbbe4183772a6675fb2)
+++ npl/syn3/webint/src/openvpn/lang_en.php	(revision 031ab693def62c4aaf3e6440e1655c4fe368b6c4)
@@ -64,4 +64,20 @@
 );}
 
+function _OpenVPNPushDNS($a="",$b="",$c="",$d="") { return (
+	"DNS server for clients"
+);}
+
+function _OpenVPNRouteMode($a="",$b="",$c="",$d="") { return (
+	"Routing mode"
+);}
+
+function _OpenVPNRouteModeAll($a="",$b="",$c="",$d="") { return (
+	"Route all internet traffic via server"
+);}
+
+function _OpenVPNRouteModeSubnet($a="",$b="",$c="",$d="") { return (
+	"Route a specific subnet"
+);}
+
 function _OpenVPNServerHost($a="",$b="",$c="",$d="") { return (
 	"OpenVPN server host"
@@ -80,4 +96,8 @@
 );}
 
+function _OpenVPNSubnetToRoute($a="",$b="",$c="",$d="") { return (
+	"Routing subnet"
+);}
+
 function _RemoteIP($a="",$b="",$c="",$d="") { return (
 	"Client IP"
Index: npl/syn3/webint/src/openvpn/lang_enD.php
===================================================================
--- npl/syn3/webint/src/openvpn/lang_enD.php	(revision 90f43e52628c9bbe952fdbbbe4183772a6675fb2)
+++ npl/syn3/webint/src/openvpn/lang_enD.php	(revision 031ab693def62c4aaf3e6440e1655c4fe368b6c4)
@@ -64,4 +64,20 @@
 );}
 
+function _OpenVPNPushDNS($a="",$b="",$c="",$d="") { LangDebug("DNS server for clients", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?edit_ID=8314");return (
+	"DNS server for clients"
+);}
+
+function _OpenVPNRouteMode($a="",$b="",$c="",$d="") { LangDebug("Routing mode", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?edit_ID=8315");return (
+	"Routing mode"
+);}
+
+function _OpenVPNRouteModeAll($a="",$b="",$c="",$d="") { LangDebug("Route all internet traffic via server", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?edit_ID=8318");return (
+	"Route all internet traffic via server"
+);}
+
+function _OpenVPNRouteModeSubnet($a="",$b="",$c="",$d="") { LangDebug("Route a specific subnet", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?edit_ID=8317");return (
+	"Route a specific subnet"
+);}
+
 function _OpenVPNServerHost($a="",$b="",$c="",$d="") { LangDebug("OpenVPN server host", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?edit_ID=8290");return (
 	"OpenVPN server host"
@@ -80,4 +96,8 @@
 );}
 
+function _OpenVPNSubnetToRoute($a="",$b="",$c="",$d="") { LangDebug("Routing subnet", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?edit_ID=8316");return (
+	"Routing subnet"
+);}
+
 function _RemoteIP($a="",$b="",$c="",$d="") { LangDebug("Client IP", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?edit_ID=8294");return (
 	"Client IP"
Index: npl/syn3/webint/src/openvpn/lang_nl.php
===================================================================
--- npl/syn3/webint/src/openvpn/lang_nl.php	(revision 90f43e52628c9bbe952fdbbbe4183772a6675fb2)
+++ npl/syn3/webint/src/openvpn/lang_nl.php	(revision 031ab693def62c4aaf3e6440e1655c4fe368b6c4)
@@ -64,4 +64,20 @@
 );}
 
+function _OpenVPNPushDNS($a="",$b="",$c="",$d="") { return (
+	"DNS server voor clients"
+);}
+
+function _OpenVPNRouteMode($a="",$b="",$c="",$d="") { return (
+	"Routing modus"
+);}
+
+function _OpenVPNRouteModeAll($a="",$b="",$c="",$d="") { return (
+	"Routeer al het internet verkeer via de server."
+);}
+
+function _OpenVPNRouteModeSubnet($a="",$b="",$c="",$d="") { return (
+	"Routeer alleen een bepaald subnet naar de server"
+);}
+
 function _OpenVPNServerHost($a="",$b="",$c="",$d="") { return (
 	"OpenVPN server host"
@@ -80,4 +96,8 @@
 );}
 
+function _OpenVPNSubnetToRoute($a="",$b="",$c="",$d="") { return (
+	"Routering subnet"
+);}
+
 function _RemoteIP($a="",$b="",$c="",$d="") { return (
 	"Client IP"
Index: npl/syn3/webint/src/openvpn/lang_nlD.php
===================================================================
--- npl/syn3/webint/src/openvpn/lang_nlD.php	(revision 90f43e52628c9bbe952fdbbbe4183772a6675fb2)
+++ npl/syn3/webint/src/openvpn/lang_nlD.php	(revision 031ab693def62c4aaf3e6440e1655c4fe368b6c4)
@@ -64,4 +64,20 @@
 );}
 
+function _OpenVPNPushDNS($a="",$b="",$c="",$d="") { LangDebug("DNS server voor clients", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?edit_ID=8309");return (
+	"DNS server voor clients"
+);}
+
+function _OpenVPNRouteMode($a="",$b="",$c="",$d="") { LangDebug("Routing modus", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?edit_ID=8310");return (
+	"Routing modus"
+);}
+
+function _OpenVPNRouteModeAll($a="",$b="",$c="",$d="") { LangDebug("Routeer al het internet verkeer via de server.", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?edit_ID=8311");return (
+	"Routeer al het internet verkeer via de server."
+);}
+
+function _OpenVPNRouteModeSubnet($a="",$b="",$c="",$d="") { LangDebug("Routeer alleen een bepaald subnet naar de server", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?edit_ID=8312");return (
+	"Routeer alleen een bepaald subnet naar de server"
+);}
+
 function _OpenVPNServerHost($a="",$b="",$c="",$d="") { LangDebug("OpenVPN server host", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?edit_ID=8274");return (
 	"OpenVPN server host"
@@ -80,4 +96,8 @@
 );}
 
+function _OpenVPNSubnetToRoute($a="",$b="",$c="",$d="") { LangDebug("Routering subnet", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?edit_ID=8313");return (
+	"Routering subnet"
+);}
+
 function _RemoteIP($a="",$b="",$c="",$d="") { LangDebug("Client IP", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?edit_ID=8278");return (
 	"Client IP"
Index: npl/syn3/webint/src/openvpn/lang_pl.php
===================================================================
--- npl/syn3/webint/src/openvpn/lang_pl.php	(revision 90f43e52628c9bbe952fdbbbe4183772a6675fb2)
+++ npl/syn3/webint/src/openvpn/lang_pl.php	(revision 031ab693def62c4aaf3e6440e1655c4fe368b6c4)
@@ -64,4 +64,20 @@
 );}
 
+function _OpenVPNPushDNS($a="",$b="",$c="",$d="") { return (
+	"DNS server for clients"
+);}
+
+function _OpenVPNRouteMode($a="",$b="",$c="",$d="") { return (
+	"Routing mode"
+);}
+
+function _OpenVPNRouteModeAll($a="",$b="",$c="",$d="") { return (
+	"Route all internet traffic via server"
+);}
+
+function _OpenVPNRouteModeSubnet($a="",$b="",$c="",$d="") { return (
+	"Route a specific subnet"
+);}
+
 function _OpenVPNServerHost($a="",$b="",$c="",$d="") { return (
 	"OpenVPN server host"
@@ -80,4 +96,8 @@
 );}
 
+function _OpenVPNSubnetToRoute($a="",$b="",$c="",$d="") { return (
+	"Routing subnet"
+);}
+
 function _RemoteIP($a="",$b="",$c="",$d="") { return (
 	"Client IP"
Index: npl/syn3/webint/src/openvpn/lang_plD.php
===================================================================
--- npl/syn3/webint/src/openvpn/lang_plD.php	(revision 90f43e52628c9bbe952fdbbbe4183772a6675fb2)
+++ npl/syn3/webint/src/openvpn/lang_plD.php	(revision 031ab693def62c4aaf3e6440e1655c4fe368b6c4)
@@ -64,4 +64,20 @@
 );}
 
+function _OpenVPNPushDNS($a="",$b="",$c="",$d="") { LangDebug("DNS server for clients", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=pl&add_labelID=_OpenVPNPushDNS");return (
+	"DNS server for clients"
+);}
+
+function _OpenVPNRouteMode($a="",$b="",$c="",$d="") { LangDebug("Routing mode", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=pl&add_labelID=_OpenVPNRouteMode");return (
+	"Routing mode"
+);}
+
+function _OpenVPNRouteModeAll($a="",$b="",$c="",$d="") { LangDebug("Route all internet traffic via server", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=pl&add_labelID=_OpenVPNRouteModeAll");return (
+	"Route all internet traffic via server"
+);}
+
+function _OpenVPNRouteModeSubnet($a="",$b="",$c="",$d="") { LangDebug("Route a specific subnet", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=pl&add_labelID=_OpenVPNRouteModeSubnet");return (
+	"Route a specific subnet"
+);}
+
 function _OpenVPNServerHost($a="",$b="",$c="",$d="") { LangDebug("OpenVPN server host", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=pl&add_labelID=_OpenVPNServerHost");return (
 	"OpenVPN server host"
@@ -80,4 +96,8 @@
 );}
 
+function _OpenVPNSubnetToRoute($a="",$b="",$c="",$d="") { LangDebug("Routing subnet", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=pl&add_labelID=_OpenVPNSubnetToRoute");return (
+	"Routing subnet"
+);}
+
 function _RemoteIP($a="",$b="",$c="",$d="") { LangDebug("Client IP", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=pl&add_labelID=_RemoteIP");return (
 	"Client IP"
Index: npl/syn3/webint/src/openvpn/lang_pt.php
===================================================================
--- npl/syn3/webint/src/openvpn/lang_pt.php	(revision 90f43e52628c9bbe952fdbbbe4183772a6675fb2)
+++ npl/syn3/webint/src/openvpn/lang_pt.php	(revision 031ab693def62c4aaf3e6440e1655c4fe368b6c4)
@@ -64,4 +64,20 @@
 );}
 
+function _OpenVPNPushDNS($a="",$b="",$c="",$d="") { return (
+	"DNS server for clients"
+);}
+
+function _OpenVPNRouteMode($a="",$b="",$c="",$d="") { return (
+	"Routing mode"
+);}
+
+function _OpenVPNRouteModeAll($a="",$b="",$c="",$d="") { return (
+	"Route all internet traffic via server"
+);}
+
+function _OpenVPNRouteModeSubnet($a="",$b="",$c="",$d="") { return (
+	"Route a specific subnet"
+);}
+
 function _OpenVPNServerHost($a="",$b="",$c="",$d="") { return (
 	"OpenVPN server host"
@@ -80,4 +96,8 @@
 );}
 
+function _OpenVPNSubnetToRoute($a="",$b="",$c="",$d="") { return (
+	"Routing subnet"
+);}
+
 function _RemoteIP($a="",$b="",$c="",$d="") { return (
 	"Client IP"
Index: npl/syn3/webint/src/openvpn/lang_ptD.php
===================================================================
--- npl/syn3/webint/src/openvpn/lang_ptD.php	(revision 90f43e52628c9bbe952fdbbbe4183772a6675fb2)
+++ npl/syn3/webint/src/openvpn/lang_ptD.php	(revision 031ab693def62c4aaf3e6440e1655c4fe368b6c4)
@@ -64,4 +64,20 @@
 );}
 
+function _OpenVPNPushDNS($a="",$b="",$c="",$d="") { LangDebug("DNS server for clients", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=pt&add_labelID=_OpenVPNPushDNS");return (
+	"DNS server for clients"
+);}
+
+function _OpenVPNRouteMode($a="",$b="",$c="",$d="") { LangDebug("Routing mode", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=pt&add_labelID=_OpenVPNRouteMode");return (
+	"Routing mode"
+);}
+
+function _OpenVPNRouteModeAll($a="",$b="",$c="",$d="") { LangDebug("Route all internet traffic via server", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=pt&add_labelID=_OpenVPNRouteModeAll");return (
+	"Route all internet traffic via server"
+);}
+
+function _OpenVPNRouteModeSubnet($a="",$b="",$c="",$d="") { LangDebug("Route a specific subnet", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=pt&add_labelID=_OpenVPNRouteModeSubnet");return (
+	"Route a specific subnet"
+);}
+
 function _OpenVPNServerHost($a="",$b="",$c="",$d="") { LangDebug("OpenVPN server host", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=pt&add_labelID=_OpenVPNServerHost");return (
 	"OpenVPN server host"
@@ -80,4 +96,8 @@
 );}
 
+function _OpenVPNSubnetToRoute($a="",$b="",$c="",$d="") { LangDebug("Routing subnet", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=pt&add_labelID=_OpenVPNSubnetToRoute");return (
+	"Routing subnet"
+);}
+
 function _RemoteIP($a="",$b="",$c="",$d="") { LangDebug("Client IP", "http://www.syn-3.nl/mosaddphp/translate/editlang.php?src_lang=en&add_langID=pt&add_labelID=_RemoteIP");return (
 	"Client IP"
Index: npl/syn3/webint/src/openvpn/model.php
===================================================================
--- npl/syn3/webint/src/openvpn/model.php	(revision 90f43e52628c9bbe952fdbbbe4183772a6675fb2)
+++ npl/syn3/webint/src/openvpn/model.php	(revision 031ab693def62c4aaf3e6440e1655c4fe368b6c4)
@@ -54,6 +54,43 @@
 		return (array("SERVER"=>_InvalidHostname()));
 
+
 	FileWriteSettings("/etc/openvpn/syn3.conf", $data);
-	LogInfo(_OpenVPNSettingsChanged());
+
+    //generate additional config settings
+    $cfg=Array();
+    $cfg[]="### Additional SYN-3 OpenVPN settings";
+    $cfg[]="# will be overwritten when settings are saved in SCC";
+
+    if ($data['ROUTE_MODE']=="all")
+        $cfg[]="push 'redirect-gateway'";
+    else
+    {
+        if ($data['SUBNET'])
+        {
+            $err=Error_ValidSubnet($data['SUBNET']);
+            if ($err)
+                return (array("SUBNET"=>$err));
+
+            list($ip,$bits)=explode("/", $data['SUBNET']);
+            $netmask=CalcMask($bits);
+            $cfg[]="push 'route $ip $netmask'";
+        }
+    }
+
+    if ($data['PUSH_DNS']!="")
+    {
+        $err=Error_ValidIP($data['PUSH_DNS']);
+        if ($err)
+            return (array("PUSH_DNS"=>$err));
+
+        $cfg[]="push 'dhcp-option DNS ".$data['PUSH_DNS']."'";
+    }
+
+
+    FileWrite("/etc/openvpn/openvpn_syn3.conf",$cfg);
+    LogInfo(_OpenVPNSettingsChanged());
+
+    SvcRestart("openvpn");
+
 }
 
Index: npl/syn3/webint/src/vpn/autoconf_syn3.php
===================================================================
--- npl/syn3/webint/src/vpn/autoconf_syn3.php	(revision 90f43e52628c9bbe952fdbbbe4183772a6675fb2)
+++ npl/syn3/webint/src/vpn/autoconf_syn3.php	(revision 031ab693def62c4aaf3e6440e1655c4fe368b6c4)
@@ -1,4 +1,4 @@
 <?
-/* 
+/*
 (C) 2004-2013 DatuX - info@datux.nl
 
@@ -23,5 +23,5 @@
 ?>
 
-<? 
+<?
 /*
 Redirection verhaal met betrekking tot auto configure:
@@ -33,5 +33,5 @@
 testtunnel							instellingen testen
 listtunnels.php						klaar :D
-	
+
 */
 	$name=$_REQUEST[name];
@@ -39,6 +39,6 @@
 	$passwd=$_REQUEST[passwd];
 
-	Title(_AutoVPNConfig($name)); 
-	
+	Title(_AutoVPNConfig($name));
+
 	//read tunnel
 	$tunnel=vpn_ReadTunnel($name);
@@ -52,18 +52,28 @@
 	$remote_par.="&new_right=$tunnel[leftid]";
 	$remote_par.="&new_rightsubnet=$tunnel[leftsubnet]";
+
 	if ($tunnel[compress]=='yes')
 		$remote_par.="&new_compress=on";
 	else
 		$remote_par.="&new_compress=off";
+
+	if ($tunnel[ikev2]=='insist')
+		$remote_par.="&new_ikev2=on";
+	else
+		$remote_par.="&new_ikev2=off";
+
+
+	if ($tunnel[pfs]=='yes')
+		$remote_par.="&new_pfs=on";
+	else
+		$remote_par.="&new_pfs=off";
+
 	$remote_par.="&new_authby=$tunnel[authby]";
 	$remote_par.="&new_rightrsasigkey=".rawurlencode(vpn_ReadPubKey());
 	$remote_par.="&new_secret=".rawurlencode($secret);
-	
+
 	// url aan ONZE kant, waar pubkey andere kant uiteindelijk heen moet
 	$remote_par.="&puburi=".rawurlencode("https://$_SERVER[HTTP_HOST]/vpn/edittunnel.php?name=$name&save=1");
-	
+
 	// jump naar de tunnel config aan de andere kant
 	Redirect("https://$ip:10000/vpn/edittunnel.php?$remote_par");
-
-	
-	
